/*
 * (C) 1995-2001 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */

#include "../config.h"

#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif
#include <string.h>

#include <pvfs.h>
#include <pvfs_proto.h>


int usage(int argc, char **argv);

/* NOTES:
 *
 * This is a quick and silly little tool to allow for creation of PVFS
 * directories without the preloaded library or kernel module or whatever.  It
 * is here to make testing easier.  Enjoy.
 */
int main(int argc, char **argv)
{
	char *filename;

	if ( argc != 2 ) {
		usage(argc, argv);
		return -1;
	}
	filename=strdup(argv[1]);

	if ( pvfs_mkdir(filename, 0777) == -1 ) {
		perror("pvfs_open");
		return -1;
	}
	return 0;
}

int usage(int argc, char **argv)
{
	fprintf(stderr, "usage: %s <filename>\n", argv[0]);
	return 0;
}
/*
 * Local variables:
 *  c-indent-level: 3
 *  c-basic-offset: 3
 *  tab-width: 3
 *
 * vim: ts=3
 * End:
 */ 
