/*
 * (C) 1995-2001 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */


/* NOTES:
 *
 * This is a quick and silly little tool to allow for statfs of PVFS
 * without the preloaded library or kernel module or whatever.  It
 * is here to make testing easier.  Enjoy.
 */

#include "../config.h"
#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_SYS_STATFS_H
#include <sys/statfs.h>
#endif
#ifdef HAVE_SYS_STATVFS_H
#include <sys/statvfs.h>
#endif
#include <pvfs.h>
#include <pvfs_proto.h>
#include <stdlib.h>

#ifdef HAVE_LINUX_STATFS
int pvfs_statfs(char *path, struct statfs *buf);
#else
/* fall back on statvfs */
int pvfs_statfs(char *path, struct statvfs *buf);
#endif

int main(int argc, char **argv)
{
#ifdef HAVE_LINUX_STATFS
	struct statfs sfs;
#else
	struct statvfs sfs;
#endif
	int64_t bsize;

	if (argc <= 1 || pvfs_statfs(argv[1], &sfs) < 0) exit(1);

	bsize = sfs.f_bsize;

	printf("blksz = %Ld, total (bytes) = %Ld, free (bytes) = %Ld\n",
	bsize, (int64_t) sfs.f_blocks * bsize, (int64_t) sfs.f_bfree * bsize);
	exit(0);
}
/*
 * Local variables:
 *  c-indent-level: 3
 *  c-basic-offset: 3
 *  tab-width: 3
 *
 * vim: ts=3
 * End:
 */ 
